/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.247 Revision 1.391
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.247 2006/08/11 02:21:47 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.391 2012/04/20 19:35:37 vapier Exp $
4#
5# This eclass is for general purpose functions that most ebuilds
6# have to implement themselves.
7#
8# NB: If you add anything, please comment it!
9#
10# Maintainer: see each individual function, base-system@gentoo.org as default
11 4
12inherit multilib portability 5# @ECLASS: eutils.eclass
6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
14#
15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass!
17
18if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
19___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
20
21inherit multilib user
13 22
14DESCRIPTION="Based on the ${ECLASS} eclass" 23DESCRIPTION="Based on the ${ECLASS} eclass"
15 24
16# Wait for the supplied number of seconds. If no argument is supplied, defaults 25if has "${EAPI:-0}" 0 1 2; then
17# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not 26
18# outputting to a terminal, don't wait. For compatability purposes, the argument 27# @FUNCTION: epause
19# must be an integer greater than zero. 28# @USAGE: [seconds]
20# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 29# @DESCRIPTION:
30# Sleep for the specified number of seconds (default of 5 seconds). Useful when
31# printing a message the user should probably be reading and often used in
32# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
33# don't wait at all. Defined in EAPIs 0 1 and 2.
21epause() { 34epause() {
22 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5} 35 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
23} 36}
24 37
25# Beep the specified number of times (defaults to five). If our output 38# @FUNCTION: ebeep
26# is not a terminal, don't beep. If the EBEEP_IGNORE env var is set, 39# @USAGE: [number of beeps]
27# don't beep. 40# @DESCRIPTION:
28# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 41# Issue the specified number of beeps (default of 5 beeps). Useful when
42# printing a message the user should probably be reading and often used in
43# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
44# don't beep at all. Defined in EAPIs 0 1 and 2.
29ebeep() { 45ebeep() {
30 local n 46 local n
31 if [[ -z ${EBEEP_IGNORE} ]] ; then 47 if [[ -z ${EBEEP_IGNORE} ]] ; then
32 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 48 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
33 echo -ne "\a" 49 echo -ne "\a"
36 sleep 1 52 sleep 1
37 done 53 done
38 fi 54 fi
39} 55}
40 56
41# This function generate linker scripts in /usr/lib for dynamic 57else
42# libs in /lib. This is to fix linking problems when you have
43# the .so in /lib, and the .a in /usr/lib. What happens is that
44# in some cases when linking dynamic, the .a in /usr/lib is used
45# instead of the .so in /lib due to gcc/libtool tweaking ld's
46# library search path. This cause many builds to fail.
47# See bug #4411 for more info.
48#
49# To use, simply call:
50#
51# gen_usr_ldscript libfoo.so
52#
53# Note that you should in general use the unversioned name of
54# the library, as ldconfig should usually update it correctly
55# to point to the latest version of the library present.
56#
57# <azarah@gentoo.org> (26 Oct 2002)
58#
59gen_usr_ldscript() {
60 local lib libdir=$(get_libdir)
61 # Just make sure it exists
62 dodir /usr/${libdir}
63 58
64 for lib in "${@}" ; do 59ebeep() {
65 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT 60 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
66 /* GNU ld script 61}
67 Since Gentoo has critical dynamic libraries
68 in /lib, and the static versions in /usr/lib,
69 we need to have a "fake" dynamic lib in /usr/lib,
70 otherwise we run into linking problems.
71 62
72 See bug http://bugs.gentoo.org/4411 for more info. 63epause() {
73 */ 64 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
74 GROUP ( /${libdir}/${lib} ) 65}
75 END_LDSCRIPT 66
76 fperms a+x "/usr/${libdir}/${lib}" || die "could not change perms on ${lib}" 67fi
68
69# @FUNCTION: eqawarn
70# @USAGE: [message]
71# @DESCRIPTION:
72# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
73# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
74# profile.
75if ! declare -F eqawarn >/dev/null ; then
76 eqawarn() {
77 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
78 :
79 }
80fi
81
82# @FUNCTION: ecvs_clean
83# @USAGE: [list of dirs]
84# @DESCRIPTION:
85# Remove CVS directories recursiveley. Useful when a source tarball contains
86# internal CVS directories. Defaults to $PWD.
87ecvs_clean() {
88 [[ -z $* ]] && set -- .
89 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
90 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
91}
92
93# @FUNCTION: esvn_clean
94# @USAGE: [list of dirs]
95# @DESCRIPTION:
96# Remove .svn directories recursiveley. Useful when a source tarball contains
97# internal Subversion directories. Defaults to $PWD.
98esvn_clean() {
99 [[ -z $* ]] && set -- .
100 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
101}
102
103# @FUNCTION: estack_push
104# @USAGE: <stack> [items to push]
105# @DESCRIPTION:
106# Push any number of items onto the specified stack. Pick a name that
107# is a valid variable (i.e. stick to alphanumerics), and push as many
108# items as you like onto the stack at once.
109#
110# The following code snippet will echo 5, then 4, then 3, then ...
111# @CODE
112# estack_push mystack 1 2 3 4 5
113# while estack_pop mystack i ; do
114# echo "${i}"
77 done 115# done
116# @CODE
117estack_push() {
118 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
119 local stack_name="__ESTACK_$1__" ; shift
120 eval ${stack_name}+=\( \"\$@\" \)
78} 121}
79 122
123# @FUNCTION: estack_pop
124# @USAGE: <stack> [variable]
125# @DESCRIPTION:
126# Pop a single item off the specified stack. If a variable is specified,
127# the popped item is stored there. If no more items are available, return
128# 1, else return 0. See estack_push for more info.
129estack_pop() {
130 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
80 131
81# Default directory where patches are located 132 # We use the fugly __estack_xxx var names to avoid collision with
133 # passing back the return value. If we used "local i" and the
134 # caller ran `estack_pop ... i`, we'd end up setting the local
135 # copy of "i" rather than the caller's copy. The __estack_xxx
136 # garbage is preferable to using $1/$2 everywhere as that is a
137 # bit harder to read.
138 local __estack_name="__ESTACK_$1__" ; shift
139 local __estack_retvar=$1 ; shift
140 eval local __estack_i=\${#${__estack_name}\[@\]}
141 # Don't warn -- let the caller interpret this as a failure
142 # or as normal behavior (akin to `shift`)
143 [[ $(( --__estack_i )) -eq -1 ]] && return 1
144
145 if [[ -n ${__estack_retvar} ]] ; then
146 eval ${__estack_retvar}=\"\${${__estack_name}\[${__estack_i}\]}\"
147 fi
148 eval unset ${__estack_name}\[${__estack_i}\]
149}
150
151# @FUNCTION: eshopts_push
152# @USAGE: [options to `set` or `shopt`]
153# @DESCRIPTION:
154# Often times code will want to enable a shell option to change code behavior.
155# Since changing shell options can easily break other pieces of code (which
156# assume the default state), eshopts_push is used to (1) push the current shell
157# options onto a stack and (2) pass the specified arguments to set.
158#
159# If the first argument is '-s' or '-u', we assume you want to call `shopt`
160# rather than `set` as there are some options only available via that.
161#
162# A common example is to disable shell globbing so that special meaning/care
163# may be used with variables/arguments to custom functions. That would be:
164# @CODE
165# eshopts_push -s noglob
166# for x in ${foo} ; do
167# if ...some check... ; then
168# eshopts_pop
169# return 0
170# fi
171# done
172# eshopts_pop
173# @CODE
174eshopts_push() {
175 if [[ $1 == -[su] ]] ; then
176 estack_push eshopts "$(shopt -p)"
177 [[ $# -eq 0 ]] && return 0
178 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
179 else
180 estack_push eshopts $-
181 [[ $# -eq 0 ]] && return 0
182 set "$@" || die "${FUNCNAME}: bad options to set: $*"
183 fi
184}
185
186# @FUNCTION: eshopts_pop
187# @USAGE:
188# @DESCRIPTION:
189# Restore the shell options to the state saved with the corresponding
190# eshopts_push call. See that function for more details.
191eshopts_pop() {
192 local s
193 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
194 if [[ ${s} == "shopt -"* ]] ; then
195 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
196 else
197 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
198 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
199 fi
200}
201
202# @FUNCTION: eumask_push
203# @USAGE: <new umask>
204# @DESCRIPTION:
205# Set the umask to the new value specified while saving the previous
206# value onto a stack. Useful for temporarily changing the umask.
207eumask_push() {
208 estack_push eumask "$(umask)"
209 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
210}
211
212# @FUNCTION: eumask_pop
213# @USAGE:
214# @DESCRIPTION:
215# Restore the previous umask state.
216eumask_pop() {
217 [[ $# -eq 0 ]] || die "${FUNCNAME}: we take no options"
218 local s
219 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
220 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
221}
222
223# @VARIABLE: EPATCH_SOURCE
224# @DESCRIPTION:
225# Default directory to search for patches.
82EPATCH_SOURCE="${WORKDIR}/patch" 226EPATCH_SOURCE="${WORKDIR}/patch"
83# Default extension for patches 227# @VARIABLE: EPATCH_SUFFIX
228# @DESCRIPTION:
229# Default extension for patches (do not prefix the period yourself).
84EPATCH_SUFFIX="patch.bz2" 230EPATCH_SUFFIX="patch.bz2"
85# Default options for patch 231# @VARIABLE: EPATCH_OPTS
232# @DESCRIPTION:
233# Options to pass to patch. Meant for ebuild/package-specific tweaking
234# such as forcing the patch level (-p#) or fuzz (-F#) factor. Note that
235# for single patch tweaking, you can also pass flags directly to epatch.
236EPATCH_OPTS=""
237# @VARIABLE: EPATCH_COMMON_OPTS
238# @DESCRIPTION:
239# Common options to pass to `patch`. You probably should never need to
240# change these. If you do, please discuss it with base-system first to
241# be sure.
242# @CODE
86# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 243# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
87# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 244# --no-backup-if-mismatch - do not leave .orig files behind
88# Set -E to automatically remove empty files. 245# -E - automatically remove empty files
246# @CODE
89EPATCH_OPTS="-g0 -E --no-backup-if-mismatch" 247EPATCH_COMMON_OPTS="-g0 -E --no-backup-if-mismatch"
248# @VARIABLE: EPATCH_EXCLUDE
249# @DESCRIPTION:
90# List of patches not to apply. Not this is only file names, 250# List of patches not to apply. Note this is only file names,
91# and not the full path .. 251# and not the full path. Globs accepted.
92EPATCH_EXCLUDE="" 252EPATCH_EXCLUDE=""
253# @VARIABLE: EPATCH_SINGLE_MSG
254# @DESCRIPTION:
93# Change the printed message for a single patch. 255# Change the printed message for a single patch.
94EPATCH_SINGLE_MSG="" 256EPATCH_SINGLE_MSG=""
257# @VARIABLE: EPATCH_MULTI_MSG
258# @DESCRIPTION:
95# Change the printed message for multiple patches. 259# Change the printed message for multiple patches.
96EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 260EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
97# Force applying bulk patches even if not following the style: 261# @VARIABLE: EPATCH_FORCE
98# 262# @DESCRIPTION:
99# ??_${ARCH}_foo.${EPATCH_SUFFIX} 263# Only require patches to match EPATCH_SUFFIX rather than the extended
100# 264# arch naming style.
101EPATCH_FORCE="no" 265EPATCH_FORCE="no"
102 266
103# This function is for bulk patching, or in theory for just one 267# @FUNCTION: epatch
104# or two patches. 268# @USAGE: [options] [patches] [dirs of patches]
269# @DESCRIPTION:
270# epatch is designed to greatly simplify the application of patches. It can
271# process patch files directly, or directories of patches. The patches may be
272# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
273# the -p option as epatch will automatically attempt -p0 to -p5 until things
274# apply successfully.
105# 275#
106# It should work with .bz2, .gz, .zip and plain text patches. 276# If you do not specify any patches/dirs, then epatch will default to the
107# Currently all patches should be the same format. 277# directory specified by EPATCH_SOURCE.
108# 278#
109# You do not have to specify '-p' option to patch, as it will 279# Any options specified that start with a dash will be passed down to patch
110# try with -p0 to -p5 until it succeed, or fail at -p5. 280# for this specific invocation. As soon as an arg w/out a dash is found, then
281# arg processing stops.
111# 282#
112# Above EPATCH_* variables can be used to control various defaults, 283# When processing directories, epatch will apply all patches that match:
113# bug they should be left as is to ensure an ebuild can rely on 284# @CODE
114# them for. 285# if ${EPATCH_FORCE} != "yes"
115#
116# Patches are applied in current directory.
117#
118# Bulk Patches should preferibly have the form of:
119#
120# ??_${ARCH}_foo.${EPATCH_SUFFIX} 286# ??_${ARCH}_foo.${EPATCH_SUFFIX}
287# else
288# *.${EPATCH_SUFFIX}
289# @CODE
290# The leading ?? are typically numbers used to force consistent patch ordering.
291# The arch field is used to apply patches only for the host architecture with
292# the special value of "all" means apply for everyone. Note that using values
293# other than "all" is highly discouraged -- you should apply patches all the
294# time and let architecture details be detected at configure/compile time.
121# 295#
122# For example: 296# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
297# for patches to apply.
123# 298#
124# 01_all_misc-fix.patch.bz2 299# Refer to the other EPATCH_xxx variables for more customization of behavior.
125# 02_sparc_another-fix.patch.bz2
126#
127# This ensures that there are a set order, and you can have ARCH
128# specific patches.
129#
130# If you however give an argument to epatch(), it will treat it as a
131# single patch that need to be applied if its a file. If on the other
132# hand its a directory, it will set EPATCH_SOURCE to this.
133#
134# <azarah@gentoo.org> (10 Nov 2002)
135#
136epatch() { 300epatch() {
137 _epatch_draw_line() { 301 _epatch_draw_line() {
302 # create a line of same length as input string
138 [[ -z $1 ]] && set "$(printf "%65s" '')" 303 [[ -z $1 ]] && set "$(printf "%65s" '')"
139 echo "${1//?/=}" 304 echo "${1//?/=}"
140 } 305 }
141 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
142 local PIPE_CMD=""
143 local STDERR_TARGET="${T}/$$.out"
144 local PATCH_TARGET="${T}/$$.patch"
145 local PATCH_SUFFIX=""
146 local SINGLE_PATCH="no"
147 local x=""
148 306
149 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 307 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
150 308
151 if [ "$#" -gt 1 ] 309 # First process options. We localize the EPATCH_OPTS setting
152 then 310 # from above so that we can pass it on in the loop below with
311 # any additional values the user has specified.
312 local EPATCH_OPTS=( ${EPATCH_OPTS[*]} )
313 while [[ $# -gt 0 ]] ; do
314 case $1 in
315 -*) EPATCH_OPTS+=( "$1" ) ;;
316 *) break ;;
317 esac
318 shift
319 done
320
321 # Let the rest of the code process one user arg at a time --
322 # each arg may expand into multiple patches, and each arg may
323 # need to start off with the default global EPATCH_xxx values
324 if [[ $# -gt 1 ]] ; then
153 local m="" 325 local m
154 for m in "$@" ; do 326 for m in "$@" ; do
155 epatch "${m}" 327 epatch "${m}"
156 done 328 done
157 return 0 329 return 0
158 fi 330 fi
159 331
160 if [ -n "$1" -a -f "$1" ] 332 local SINGLE_PATCH="no"
161 then 333 # no args means process ${EPATCH_SOURCE}
334 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
335
336 if [[ -f $1 ]] ; then
162 SINGLE_PATCH="yes" 337 SINGLE_PATCH="yes"
163 338 set -- "$1"
164 local EPATCH_SOURCE="$1" 339 # Use the suffix from the single patch (localize it); the code
340 # below will find the suffix for us
165 local EPATCH_SUFFIX="${1##*\.}" 341 local EPATCH_SUFFIX=$1
166 342
167 elif [ -n "$1" -a -d "$1" ] 343 elif [[ -d $1 ]] ; then
168 then 344 # Some people like to make dirs of patches w/out suffixes (vim)
169 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 345 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
170 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 346
347 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
348 # Re-use EPATCH_SOURCE as a search dir
349 epatch "${EPATCH_SOURCE}/$1"
350 return $?
351
352 else
353 # sanity check ... if it isn't a dir or file, wtf man ?
354 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
355 echo
356 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
357 eerror
358 eerror " ${EPATCH_SOURCE}"
359 eerror " ( ${EPATCH_SOURCE##*/} )"
360 echo
361 die "Cannot find \$EPATCH_SOURCE!"
362 fi
363
364 # Now that we know we're actually going to apply something, merge
365 # all of the patch options back in to a single variable for below.
366 EPATCH_OPTS="${EPATCH_COMMON_OPTS} ${EPATCH_OPTS[*]}"
367
368 local PIPE_CMD
369 case ${EPATCH_SUFFIX##*\.} in
370 xz) PIPE_CMD="xz -dc" ;;
371 lzma) PIPE_CMD="lzma -dc" ;;
372 bz2) PIPE_CMD="bzip2 -dc" ;;
373 gz|Z|z) PIPE_CMD="gzip -dc" ;;
374 ZIP|zip) PIPE_CMD="unzip -p" ;;
375 *) ;;
376 esac
377
378 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
379
380 local x
381 for x in "$@" ; do
382 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
383 # didn't match anything, ignore continue on
384 [[ ! -f ${x} ]] && continue
385
386 local patchname=${x##*/}
387
388 # Apply single patches, or forced sets of patches, or
389 # patches with ARCH dependant names.
390 # ???_arch_foo.patch
391 # Else, skip this input altogether
392 local a=${patchname#*_} # strip the ???_
393 a=${a%%_*} # strip the _foo.patch
394 if ! [[ ${SINGLE_PATCH} == "yes" || \
395 ${EPATCH_FORCE} == "yes" || \
396 ${a} == all || \
397 ${a} == ${ARCH} ]]
171 then 398 then
172 local EPATCH_SOURCE="$1/*" 399 continue
400 fi
401
402 # Let people filter things dynamically
403 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
404 # let people use globs in the exclude
405 eshopts_push -o noglob
406
407 local ex
408 for ex in ${EPATCH_EXCLUDE} ; do
409 if [[ ${patchname} == ${ex} ]] ; then
410 eshopts_pop
411 continue 2
412 fi
413 done
414
415 eshopts_pop
416 fi
417
418 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
419 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
420 einfo "${EPATCH_SINGLE_MSG}"
421 else
422 einfo "Applying ${patchname} ..."
423 fi
173 else 424 else
174 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 425 einfo " ${patchname} ..."
175 fi 426 fi
176 else 427
177 if [ ! -d ${EPATCH_SOURCE} ] || [ -n "$1" ] 428 # most of the time, there will only be one run per unique name,
178 then 429 # but if there are more, make sure we get unique log filenames
179 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 430 local STDERR_TARGET="${T}/${patchname}.out"
180 then 431 if [[ -e ${STDERR_TARGET} ]] ; then
181 EPATCH_SOURCE="$1" 432 STDERR_TARGET="${T}/${patchname}-$$.out"
433 fi
434
435 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
436
437 # Decompress the patch if need be
438 local count=0
439 local PATCH_TARGET
440 if [[ -n ${PIPE_CMD} ]] ; then
441 PATCH_TARGET="${T}/$$.patch"
442 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
443
444 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
445 echo
446 eerror "Could not extract patch!"
447 #die "Could not extract patch!"
448 count=5
449 break
182 fi 450 fi
451 else
452 PATCH_TARGET=${x}
453 fi
183 454
455 # Check for absolute paths in patches. If sandbox is disabled,
456 # people could (accidently) patch files in the root filesystem.
457 # Or trigger other unpleasantries #237667. So disallow -p0 on
458 # such patches.
459 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
460 if [[ -n ${abs_paths} ]] ; then
461 count=1
462 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
463 fi
464 # Similar reason, but with relative paths.
465 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
466 if [[ -n ${rel_paths} ]] ; then
467 eqawarn "QA Notice: Your patch uses relative paths '../'."
468 eqawarn " In the future this will cause a failure."
469 eqawarn "${rel_paths}"
470 fi
471
472 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
473 local patch_cmd
474 while [[ ${count} -lt 5 ]] ; do
475 patch_cmd="${BASH_ALIASES[patch]:-patch} -p${count} ${EPATCH_OPTS}"
476
477 # Generate some useful debug info ...
478 (
479 _epatch_draw_line "***** ${patchname} *****"
184 echo 480 echo
185 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 481 echo "PATCH COMMAND: ${patch_cmd} < '${PATCH_TARGET}'"
482 echo
483 _epatch_draw_line "***** ${patchname} *****"
484 ${patch_cmd} --dry-run -f < "${PATCH_TARGET}" 2>&1
485 ret=$?
486 echo
487 echo "patch program exited with status ${ret}"
488 exit ${ret}
489 ) >> "${STDERR_TARGET}"
490
491 if [ $? -eq 0 ] ; then
492 (
493 _epatch_draw_line "***** ${patchname} *****"
494 echo
495 echo "ACTUALLY APPLYING ${patchname} ..."
496 echo
497 _epatch_draw_line "***** ${patchname} *****"
498 ${patch_cmd} < "${PATCH_TARGET}" 2>&1
499 ret=$?
500 echo
501 echo "patch program exited with status ${ret}"
502 exit ${ret}
503 ) >> "${STDERR_TARGET}"
504
505 if [ $? -ne 0 ] ; then
506 echo
507 eerror "A dry-run of patch command succeeded, but actually"
508 eerror "applying the patch failed!"
509 #die "Real world sux compared to the dreamworld!"
510 count=5
511 fi
512 break
513 fi
514
515 : $(( count++ ))
516 done
517
518 # if we had to decompress the patch, delete the temp one
519 if [[ -n ${PIPE_CMD} ]] ; then
520 rm -f "${PATCH_TARGET}"
521 fi
522
523 if [[ ${count} -ge 5 ]] ; then
524 echo
525 eerror "Failed Patch: ${patchname} !"
526 eerror " ( ${PATCH_TARGET} )"
186 eerror 527 eerror
187 eerror " ${EPATCH_SOURCE}" 528 eerror "Include in your bugreport the contents of:"
188 eerror " ( ${EPATCH_SOURCE##*/} )" 529 eerror
530 eerror " ${STDERR_TARGET}"
189 echo 531 echo
190 die "Cannot find \$EPATCH_SOURCE!"
191 fi
192
193 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
194 fi
195
196 case ${EPATCH_SUFFIX##*\.} in
197 bz2)
198 PIPE_CMD="bzip2 -dc"
199 PATCH_SUFFIX="bz2"
200 ;;
201 gz|Z|z)
202 PIPE_CMD="gzip -dc"
203 PATCH_SUFFIX="gz"
204 ;;
205 ZIP|zip)
206 PIPE_CMD="unzip -p"
207 PATCH_SUFFIX="zip"
208 ;;
209 *)
210 PIPE_CMD="cat"
211 PATCH_SUFFIX="patch"
212 ;;
213 esac
214
215 if [ "${SINGLE_PATCH}" = "no" ]
216 then
217 einfo "${EPATCH_MULTI_MSG}"
218 fi
219 for x in ${EPATCH_SOURCE}
220 do
221 # New ARCH dependant patch naming scheme ...
222 #
223 # ???_arch_foo.patch
224 #
225 if [ -f ${x} ] && \
226 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
227 [ "${EPATCH_FORCE}" = "yes" ])
228 then
229 local count=0
230 local popts="${EPATCH_OPTS}"
231 local patchname=${x##*/}
232
233 if [ -n "${EPATCH_EXCLUDE}" ]
234 then
235 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
236 then
237 continue
238 fi
239 fi
240
241 if [ "${SINGLE_PATCH}" = "yes" ]
242 then
243 if [ -n "${EPATCH_SINGLE_MSG}" ]
244 then
245 einfo "${EPATCH_SINGLE_MSG}"
246 else
247 einfo "Applying ${patchname} ..."
248 fi
249 else
250 einfo " ${patchname} ..."
251 fi
252
253 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
254 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
255
256 # Allow for prefix to differ ... im lazy, so shoot me :/
257 while [ "${count}" -lt 5 ]
258 do
259 # Generate some useful debug info ...
260 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
261 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
262
263 if [ "${PATCH_SUFFIX}" != "patch" ]
264 then
265 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
266 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
267 else
268 PATCH_TARGET="${x}"
269 fi
270
271 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
272 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
273
274 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
275 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
276
277 if [ "${PATCH_SUFFIX}" != "patch" ]
278 then
279 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
280 then
281 echo
282 eerror "Could not extract patch!"
283 #die "Could not extract patch!"
284 count=5
285 break
286 fi
287 fi
288
289 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
290 then
291 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
292 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
293 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
294 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
295 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
296
297 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
298 _epatch_assert
299
300 if [ "$?" -ne 0 ]
301 then
302 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
303 echo
304 eerror "A dry-run of patch command succeeded, but actually"
305 eerror "applying the patch failed!"
306 #die "Real world sux compared to the dreamworld!"
307 count=5
308 fi
309
310 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
311
312 break
313 fi
314
315 count=$((count + 1))
316 done
317
318 if [ "${PATCH_SUFFIX}" != "patch" ]
319 then
320 rm -f ${PATCH_TARGET}
321 fi
322
323 if [ "${count}" -eq 5 ]
324 then
325 echo
326 eerror "Failed Patch: ${patchname} !"
327 eerror " ( ${PATCH_TARGET} )"
328 eerror
329 eerror "Include in your bugreport the contents of:"
330 eerror
331 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
332 echo
333 die "Failed Patch: ${patchname}!" 532 die "Failed Patch: ${patchname}!"
334 fi 533 fi
335 534
336 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 535 # if everything worked, delete the full debug patch log
536 rm -f "${STDERR_TARGET}"
337 537
538 # then log away the exact stuff for people to review later
539 cat <<-EOF >> "${T}/epatch.log"
540 PATCH: ${x}
541 CMD: ${patch_cmd}
542 PWD: ${PWD}
543
544 EOF
338 eend 0 545 eend 0
339 fi
340 done 546 done
341 if [ "${SINGLE_PATCH}" = "no" ] 547
342 then 548 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
343 einfo "Done with patching" 549 : # everything worked
550}
551
552# @FUNCTION: epatch_user
553# @USAGE:
554# @DESCRIPTION:
555# Applies user-provided patches to the source tree. The patches are
556# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
557# of these three directories to exist will be the one to use, ignoring
558# any more general directories which might exist as well. They must end
559# in ".patch" to be applied.
560#
561# User patches are intended for quick testing of patches without ebuild
562# modifications, as well as for permanent customizations a user might
563# desire. Obviously, there can be no official support for arbitrarily
564# patched ebuilds. So whenever a build log in a bug report mentions that
565# user patches were applied, the user should be asked to reproduce the
566# problem without these.
567#
568# Not all ebuilds do call this function, so placing patches in the
569# stated directory might or might not work, depending on the package and
570# the eclasses it inherits and uses. It is safe to call the function
571# repeatedly, so it is always possible to add a call at the ebuild
572# level. The first call is the time when the patches will be
573# applied.
574#
575# Ideally, this function should be called after gentoo-specific patches
576# have been applied, so that their code can be modified as well, but
577# before calls to e.g. eautoreconf, as the user patches might affect
578# autotool input files as well.
579epatch_user() {
580 [[ $# -ne 0 ]] && die "epatch_user takes no options"
581
582 # Allow multiple calls to this function; ignore all but the first
583 local applied="${T}/epatch_user.log"
584 [[ -e ${applied} ]] && return 2
585
586 # don't clobber any EPATCH vars that the parent might want
587 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
588 for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}; do
589 EPATCH_SOURCE=${base}/${CTARGET}/${check}
590 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
591 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
592 if [[ -d ${EPATCH_SOURCE} ]] ; then
593 EPATCH_SOURCE=${EPATCH_SOURCE} \
594 EPATCH_SUFFIX="patch" \
595 EPATCH_FORCE="yes" \
596 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
597 epatch
598 echo "${EPATCH_SOURCE}" > "${applied}"
599 return 0
344 fi 600 fi
601 done
602 echo "none" > "${applied}"
603 return 1
345} 604}
346 605
606# @FUNCTION: emktemp
607# @USAGE: [temp dir]
608# @DESCRIPTION:
347# Cheap replacement for when debianutils (and thus mktemp) 609# Cheap replacement for when debianutils (and thus mktemp)
348# does not exist on the users system 610# does not exist on the users system.
349# vapier@gentoo.org
350#
351# Takes just 1 optional parameter (the directory to create tmpfile in)
352emktemp() { 611emktemp() {
353 local exe="touch" 612 local exe="touch"
354 [[ $1 == -d ]] && exe="mkdir" && shift 613 [[ $1 == -d ]] && exe="mkdir" && shift
355 local topdir=$1 614 local topdir=$1
356 615
358 [[ -z ${T} ]] \ 617 [[ -z ${T} ]] \
359 && topdir="/tmp" \ 618 && topdir="/tmp" \
360 || topdir=${T} 619 || topdir=${T}
361 fi 620 fi
362 621
363 if [[ -z $(type -p mktemp) ]] ; then 622 if ! type -P mktemp > /dev/null ; then
623 # system lacks `mktemp` so we have to fake it
364 local tmp=/ 624 local tmp=/
365 while [[ -e ${tmp} ]] ; do 625 while [[ -e ${tmp} ]] ; do
366 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM} 626 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
367 done 627 done
368 ${exe} "${tmp}" || ${exe} -p "${tmp}" 628 ${exe} "${tmp}" || ${exe} -p "${tmp}"
369 echo "${tmp}" 629 echo "${tmp}"
370 else 630 else
631 # the args here will give slightly wierd names on BSD,
632 # but should produce a usable file on all userlands
371 if [[ ${exe} == "touch" ]] ; then 633 if [[ ${exe} == "touch" ]] ; then
372 [[ ${USERLAND} == "GNU" ]] \
373 && mktemp -p "${topdir}" \
374 || TMPDIR="${topdir}" mktemp -t tmp 634 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
375 else 635 else
376 [[ ${USERLAND} == "GNU" ]] \
377 && mktemp -d "${topdir}" \
378 || TMPDIR="${topdir}" mktemp -dt tmp 636 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
379 fi
380 fi
381}
382
383# Small wrapper for getent (Linux), nidump (Mac OS X),
384# and pw (FreeBSD) used in enewuser()/enewgroup()
385# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
386# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org>
387#
388# egetent(database, key)
389egetent() {
390 case ${CHOST} in
391 *-darwin*)
392 case "$2" in
393 *[!0-9]*) # Non numeric
394 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
395 ;;
396 *) # Numeric
397 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
398 ;;
399 esac
400 ;;
401 *-freebsd*|*-dragonfly*)
402 local opts action="user"
403 [[ $1 == "passwd" ]] || action="group"
404
405 # lookup by uid/gid
406 if [[ $2 == [[:digit:]]* ]] ; then
407 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
408 fi
409
410 pw show ${action} ${opts} "$2" -q
411 ;;
412 *-netbsd*|*-openbsd*)
413 grep "$2:\*:" /etc/$1
414 ;;
415 *)
416 type -p nscd >& /dev/null && nscd -i "$1"
417 getent "$1" "$2"
418 ;;
419 esac
420}
421
422# Simplify/standardize adding users to the system
423# vapier@gentoo.org
424#
425# enewuser(username, uid, shell, homedir, groups, extra options)
426#
427# Default values if you do not specify any:
428# username: REQUIRED !
429# uid: next available (see useradd(8))
430# note: pass -1 to get default behavior
431# shell: /bin/false
432# homedir: /dev/null
433# groups: none
434# extra: comment of 'added by portage for ${PN}'
435enewuser() {
436 case ${EBUILD_PHASE} in
437 unpack|compile|test|install)
438 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
439 eerror "Package fails at QA and at life. Please file a bug."
440 die "Bad package! enewuser is only for use in pkg_* functions!"
441 esac
442
443 # get the username
444 local euser=$1; shift
445 if [[ -z ${euser} ]] ; then
446 eerror "No username specified !"
447 die "Cannot call enewuser without a username"
448 fi
449
450 # lets see if the username already exists
451 if [[ ${euser} == $(egetent passwd "${euser}" | cut -d: -f1) ]] ; then
452 return 0
453 fi
454 einfo "Adding user '${euser}' to your system ..."
455
456 # options to pass to useradd
457 local opts=
458
459 # handle uid
460 local euid=$1; shift
461 if [[ ! -z ${euid} ]] && [[ ${euid} != "-1" ]] ; then
462 if [[ ${euid} -gt 0 ]] ; then
463 if [[ ! -z $(egetent passwd ${euid}) ]] ; then
464 euid="next"
465 fi 637 fi
466 else
467 eerror "Userid given but is not greater than 0 !"
468 die "${euid} is not a valid UID"
469 fi 638 fi
470 else
471 euid="next"
472 fi
473 if [[ ${euid} == "next" ]] ; then
474 for euid in $(seq 101 999) ; do
475 [[ -z $(egetent passwd ${euid}) ]] && break
476 done
477 fi
478 opts="${opts} -u ${euid}"
479 einfo " - Userid: ${euid}"
480
481 # handle shell
482 local eshell=$1; shift
483 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
484 if [[ ! -e ${ROOT}${eshell} ]] ; then
485 eerror "A shell was specified but it does not exist !"
486 die "${eshell} does not exist in ${ROOT}"
487 fi
488 if [[ ${eshell} == */false || ${eshell} == */nologin ]] ; then
489 eerror "Do not specify ${eshell} yourself, use -1"
490 die "Pass '-1' as the shell parameter"
491 fi
492 else
493 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
494 [[ -x ${ROOT}${shell} ]] && break
495 done
496
497 if [[ ${shell} == "/dev/null" ]] ; then
498 eerror "Unable to identify the shell to use"
499 die "Unable to identify the shell to use"
500 fi
501
502 eshell=${shell}
503 fi
504 einfo " - Shell: ${eshell}"
505 opts="${opts} -s ${eshell}"
506
507 # handle homedir
508 local ehome=$1; shift
509 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
510 ehome="/dev/null"
511 fi
512 einfo " - Home: ${ehome}"
513 opts="${opts} -d ${ehome}"
514
515 # handle groups
516 local egroups=$1; shift
517 if [[ ! -z ${egroups} ]] ; then
518 local oldifs=${IFS}
519 local defgroup="" exgroups=""
520
521 export IFS=","
522 for g in ${egroups} ; do
523 export IFS=${oldifs}
524 if [[ -z $(egetent group "${g}") ]] ; then
525 eerror "You must add group ${g} to the system first"
526 die "${g} is not a valid GID"
527 fi
528 if [[ -z ${defgroup} ]] ; then
529 defgroup=${g}
530 else
531 exgroups="${exgroups},${g}"
532 fi
533 export IFS=","
534 done
535 export IFS=${oldifs}
536
537 opts="${opts} -g ${defgroup}"
538 if [[ ! -z ${exgroups} ]] ; then
539 opts="${opts} -G ${exgroups:1}"
540 fi
541 else
542 egroups="(none)"
543 fi
544 einfo " - Groups: ${egroups}"
545
546 # handle extra and add the user
547 local oldsandbox=${SANDBOX_ON}
548 export SANDBOX_ON="0"
549 case ${CHOST} in
550 *-darwin*)
551 ### Make the user
552 if [[ -z $@ ]] ; then
553 dscl . create /users/${euser} uid ${euid}
554 dscl . create /users/${euser} shell ${eshell}
555 dscl . create /users/${euser} home ${ehome}
556 dscl . create /users/${euser} realname "added by portage for ${PN}"
557 ### Add the user to the groups specified
558 local oldifs=${IFS}
559 export IFS=","
560 for g in ${egroups} ; do
561 dscl . merge /groups/${g} users ${euser}
562 done
563 export IFS=${oldifs}
564 else
565 einfo "Extra options are not supported on Darwin yet"
566 einfo "Please report the ebuild along with the info below"
567 einfo "eextra: $@"
568 die "Required function missing"
569 fi
570 ;;
571 *-freebsd*|*-dragonfly*)
572 if [[ -z $@ ]] ; then
573 pw useradd ${euser} ${opts} \
574 -c "added by portage for ${PN}" \
575 die "enewuser failed"
576 else
577 einfo " - Extra: $@"
578 pw useradd ${euser} ${opts} \
579 "$@" || die "enewuser failed"
580 fi
581 ;;
582
583 *-netbsd*)
584 if [[ -z $@ ]] ; then
585 useradd ${opts} ${euser} || die "enewuser failed"
586 else
587 einfo " - Extra: $@"
588 useradd ${opts} ${euser} "$@" || die "enewuser failed"
589 fi
590 ;;
591
592 *-openbsd*)
593 if [[ -z $@ ]] ; then
594 useradd -u ${euid} -s ${eshell} \
595 -d ${ehome} -c "Added by portage for ${PN}" \
596 -g ${egroups} ${euser} || die "enewuser failed"
597 else
598 einfo " - Extra: $@"
599 useradd -u ${euid} -s ${eshell} \
600 -d ${ehome} -c "Added by portage for ${PN}" \
601 -g ${egroups} ${euser} "$@" || die "enewuser failed"
602 fi
603 ;;
604
605 *)
606 if [[ -z $@ ]] ; then
607 useradd ${opts} ${euser} \
608 -c "added by portage for ${PN}" \
609 || die "enewuser failed"
610 else
611 einfo " - Extra: $@"
612 useradd ${opts} ${euser} "$@" \
613 || die "enewuser failed"
614 fi
615 ;;
616 esac
617
618 if [[ ! -e ${ROOT}/${ehome} ]] ; then
619 einfo " - Creating ${ehome} in ${ROOT}"
620 mkdir -p "${ROOT}/${ehome}"
621 chown ${euser} "${ROOT}/${ehome}"
622 chmod 755 "${ROOT}/${ehome}"
623 fi
624
625 export SANDBOX_ON=${oldsandbox}
626} 639}
627 640
628# Simplify/standardize adding groups to the system 641# @FUNCTION: edos2unix
629# vapier@gentoo.org 642# @USAGE: <file> [more files ...]
630# 643# @DESCRIPTION:
631# enewgroup(group, gid) 644# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
632# 645# to remove all of these text utilities from DEPEND variables because this
633# Default values if you do not specify any: 646# is a script based solution. Just give it a list of files to convert and
634# groupname: REQUIRED ! 647# they will all be changed from the DOS CRLF format to the UNIX LF format.
635# gid: next available (see groupadd(8))
636# extra: none
637enewgroup() {
638 case ${EBUILD_PHASE} in
639 unpack|compile|test|install)
640 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
641 eerror "Package fails at QA and at life. Please file a bug."
642 die "Bad package! enewgroup is only for use in pkg_* functions!"
643 esac
644
645 # get the group
646 local egroup="$1"; shift
647 if [ -z "${egroup}" ]
648 then
649 eerror "No group specified !"
650 die "Cannot call enewgroup without a group"
651 fi
652
653 # see if group already exists
654 if [ "${egroup}" == "`egetent group \"${egroup}\" | cut -d: -f1`" ]
655 then
656 return 0
657 fi
658 einfo "Adding group '${egroup}' to your system ..."
659
660 # options to pass to useradd
661 local opts=
662
663 # handle gid
664 local egid="$1"; shift
665 if [ ! -z "${egid}" ]
666 then
667 if [ "${egid}" -gt 0 ]
668 then
669 if [ -z "`egetent group ${egid}`" ]
670 then
671 if [[ "${CHOST}" == *-darwin* ]]; then
672 opts="${opts} ${egid}"
673 else
674 opts="${opts} -g ${egid}"
675 fi
676 else
677 egid="next available; requested gid taken"
678 fi
679 else
680 eerror "Groupid given but is not greater than 0 !"
681 die "${egid} is not a valid GID"
682 fi
683 else
684 egid="next available"
685 fi
686 einfo " - Groupid: ${egid}"
687
688 # handle extra
689 local eextra="$@"
690 opts="${opts} ${eextra}"
691
692 # add the group
693 local oldsandbox="${SANDBOX_ON}"
694 export SANDBOX_ON="0"
695 case ${CHOST} in
696 *-darwin*)
697 if [ ! -z "${eextra}" ];
698 then
699 einfo "Extra options are not supported on Darwin/OS X yet"
700 einfo "Please report the ebuild along with the info below"
701 einfo "eextra: ${eextra}"
702 die "Required function missing"
703 fi
704
705 # If we need the next available
706 case ${egid} in
707 *[!0-9]*) # Non numeric
708 for egid in $(seq 101 999); do
709 [ -z "`egetent group ${egid}`" ] && break
710 done
711 esac
712 dscl . create /groups/${egroup} gid ${egid}
713 dscl . create /groups/${egroup} passwd '*'
714 ;;
715
716 *-freebsd*|*-dragonfly*)
717 case ${egid} in
718 *[!0-9]*) # Non numeric
719 for egid in $(seq 101 999); do
720 [ -z "`egetent group ${egid}`" ] && break
721 done
722 esac
723 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
724 ;;
725
726 *-netbsd*)
727 case ${egid} in
728 *[!0-9]*) # Non numeric
729 for egid in $(seq 101 999); do
730 [ -z "`egetent group ${egid}`" ] && break
731 done
732 esac
733 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
734 ;;
735
736 *)
737 groupadd ${opts} ${egroup} || die "enewgroup failed"
738 ;;
739 esac
740 export SANDBOX_ON="${oldsandbox}"
741}
742
743# Simple script to replace 'dos2unix' binaries
744# vapier@gentoo.org
745#
746# edos2unix(file, <more files> ...)
747edos2unix() { 648edos2unix() {
748 for f in "$@" 649 [[ $# -eq 0 ]] && return 0
749 do 650 sed -i 's/\r$//' -- "$@" || die
750 cp "${f}" ${T}/edos2unix
751 sed 's/\r$//' ${T}/edos2unix > "${f}"
752 done
753} 651}
754 652
755 653# @FUNCTION: make_desktop_entry
756############################################################## 654# @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
757# START: Handle .desktop files and menu entries # 655# @DESCRIPTION:
758# maybe this should be separated into a new eclass some time #
759# lanius@gentoo.org #
760##############################################################
761
762# Make a desktop file ! 656# Make a .desktop file.
763# Great for making those icons in kde/gnome startmenu !
764# Amaze your friends ! Get the women ! Join today !
765# 657#
766# make_desktop_entry(<command>, [name], [icon], [type], [path]) 658# @CODE
767#
768# binary: what command does the app run with ? 659# binary: what command does the app run with ?
769# name: the name that will show up in the menu 660# name: the name that will show up in the menu
770# icon: give your little like a pretty little icon ... 661# icon: give your little like a pretty little icon ...
771# this can be relative (to /usr/share/pixmaps) or 662# this can be relative (to /usr/share/pixmaps) or
772# a full path to an icon 663# a full path to an icon
773# type: what kind of application is this ? for categories: 664# type: what kind of application is this?
774# http://www.freedesktop.org/Standards/desktop-entry-spec 665# for categories:
775# path: if your app needs to startup in a specific dir 666# http://standards.freedesktop.org/menu-spec/latest/apa.html
667# if unset, function tries to guess from package's category
668# fields: extra fields to append to the desktop file; a printf string
669# @CODE
776make_desktop_entry() { 670make_desktop_entry() {
777 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 671 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
778 672
779 local exec=${1} 673 local exec=${1}
780 local name=${2:-${PN}} 674 local name=${2:-${PN}}
781 local icon=${3:-${PN}.png} 675 local icon=${3:-${PN}}
782 local type=${4} 676 local type=${4}
783 local path=${5} 677 local fields=${5}
784 678
785 if [[ -z ${type} ]] ; then 679 if [[ -z ${type} ]] ; then
786 local catmaj=${CATEGORY%%-*} 680 local catmaj=${CATEGORY%%-*}
787 local catmin=${CATEGORY##*-} 681 local catmin=${CATEGORY##*-}
788 case ${catmaj} in 682 case ${catmaj} in
789 app) 683 app)
790 case ${catmin} in 684 case ${catmin} in
685 accessibility) type="Utility;Accessibility";;
791 admin) type=System;; 686 admin) type=System;;
687 antivirus) type=System;;
688 arch) type="Utility;Archiving";;
689 backup) type="Utility;Archiving";;
792 cdr) type=DiscBurning;; 690 cdr) type="AudioVideo;DiscBurning";;
793 dicts) type=Dictionary;; 691 dicts) type="Office;Dictionary";;
692 doc) type=Documentation;;
794 editors) type=TextEditor;; 693 editors) type="Utility;TextEditor";;
795 emacs) type=TextEditor;; 694 emacs) type="Development;TextEditor";;
796 emulation) type=Emulator;; 695 emulation) type="System;Emulator";;
797 laptop) type=HardwareSettings;; 696 laptop) type="Settings;HardwareSettings";;
798 office) type=Office;; 697 office) type=Office;;
698 pda) type="Office;PDA";;
799 vim) type=TextEditor;; 699 vim) type="Development;TextEditor";;
800 xemacs) type=TextEditor;; 700 xemacs) type="Development;TextEditor";;
801 *) type=;;
802 esac 701 esac
803 ;; 702 ;;
804 703
805 dev) 704 dev)
806 type="Development" 705 type="Development"
807 ;; 706 ;;
808 707
809 games) 708 games)
810 case ${catmin} in 709 case ${catmin} in
811 action) type=ActionGame;; 710 action|fps) type=ActionGame;;
812 arcade) type=ArcadeGame;; 711 arcade) type=ArcadeGame;;
813 board) type=BoardGame;; 712 board) type=BoardGame;;
814 kid) type=KidsGame;;
815 emulation) type=Emulator;; 713 emulation) type=Emulator;;
714 kids) type=KidsGame;;
816 puzzle) type=LogicGame;; 715 puzzle) type=LogicGame;;
716 roguelike) type=RolePlaying;;
817 rpg) type=RolePlaying;; 717 rpg) type=RolePlaying;;
818 roguelike) type=RolePlaying;;
819 simulation) type=Simulation;; 718 simulation) type=Simulation;;
820 sports) type=SportsGame;; 719 sports) type=SportsGame;;
821 strategy) type=StrategyGame;; 720 strategy) type=StrategyGame;;
822 *) type=;;
823 esac 721 esac
824 type="Game;${type}" 722 type="Game;${type}"
825 ;; 723 ;;
826 724
725 gnome)
726 type="Gnome;GTK"
727 ;;
728
729 kde)
730 type="KDE;Qt"
731 ;;
732
827 mail) 733 mail)
828 type="Network;Email" 734 type="Network;Email"
829 ;; 735 ;;
830 736
831 media) 737 media)
832 case ${catmin} in 738 case ${catmin} in
739 gfx)
833 gfx) type=Graphics;; 740 type=Graphics
741 ;;
742 *)
743 case ${catmin} in
834 radio) type=Tuner;; 744 radio) type=Tuner;;
835 sound) type=Audio;; 745 sound) type=Audio;;
836 tv) type=TV;; 746 tv) type=TV;;
837 video) type=Video;; 747 video) type=Video;;
838 *) type=;; 748 esac
749 type="AudioVideo;${type}"
750 ;;
839 esac 751 esac
840 type="AudioVideo;${type}"
841 ;; 752 ;;
842 753
843 net) 754 net)
844 case ${catmin} in 755 case ${catmin} in
845 dialup) type=Dialup;; 756 dialup) type=Dialup;;
848 irc) type=IRCClient;; 759 irc) type=IRCClient;;
849 mail) type=Email;; 760 mail) type=Email;;
850 news) type=News;; 761 news) type=News;;
851 nntp) type=News;; 762 nntp) type=News;;
852 p2p) type=FileTransfer;; 763 p2p) type=FileTransfer;;
853 *) type=;; 764 voip) type=Telephony;;
854 esac 765 esac
855 type="Network;${type}" 766 type="Network;${type}"
856 ;; 767 ;;
857 768
858 sci) 769 sci)
859 case ${catmin} in 770 case ${catmin} in
860 astro*) type=Astronomy;; 771 astro*) type=Astronomy;;
861 bio*) type=Biology;; 772 bio*) type=Biology;;
862 calc*) type=Calculator;; 773 calc*) type=Calculator;;
863 chem*) type=Chemistry;; 774 chem*) type=Chemistry;;
775 elec*) type=Electronics;;
864 geo*) type=Geology;; 776 geo*) type=Geology;;
865 math*) type=Math;; 777 math*) type=Math;;
866 *) type=;; 778 physics) type=Physics;;
779 visual*) type=DataVisualization;;
867 esac 780 esac
868 type="Science;${type}" 781 type="Education;Science;${type}"
782 ;;
783
784 sys)
785 type="System"
869 ;; 786 ;;
870 787
871 www) 788 www)
872 case ${catmin} in 789 case ${catmin} in
873 client) type=WebBrowser;; 790 client) type=WebBrowser;;
874 *) type=;;
875 esac 791 esac
876 type="Network" 792 type="Network;${type}"
877 ;; 793 ;;
878 794
879 *) 795 *)
880 type= 796 type=
881 ;; 797 ;;
884 if [ "${SLOT}" == "0" ] ; then 800 if [ "${SLOT}" == "0" ] ; then
885 local desktop_name="${PN}" 801 local desktop_name="${PN}"
886 else 802 else
887 local desktop_name="${PN}-${SLOT}" 803 local desktop_name="${PN}-${SLOT}"
888 fi 804 fi
889 local desktop=${T}/${exec%% *}-${desktop_name}.desktop 805 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
890# local desktop=${T}/${exec%% *:-${desktop_name}}.desktop 806 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
891 807
808 # Don't append another ";" when a valid category value is provided.
809 type=${type%;}${type:+;}
810
811 eshopts_push -s extglob
812 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
813 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
814 ewarn "allowed in .desktop files if the value is not an absolute path."
815 icon=${icon%.@(xpm|png|svg)}
816 fi
817 eshopts_pop
818
819 cat <<-EOF > "${desktop}"
892echo "[Desktop Entry] 820 [Desktop Entry]
893Encoding=UTF-8
894Version=0.9.2
895Name=${name} 821 Name=${name}
896Type=Application 822 Type=Application
897Comment=${DESCRIPTION} 823 Comment=${DESCRIPTION}
898Exec=${exec} 824 Exec=${exec}
899TryExec=${exec%% *} 825 TryExec=${exec%% *}
900Path=${path}
901Icon=${icon} 826 Icon=${icon}
902Categories=Application;${type};" > "${desktop}" 827 Categories=${type}
828 EOF
829
830 if [[ ${fields:-=} != *=* ]] ; then
831 # 5th arg used to be value to Path=
832 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
833 fields="Path=${fields}"
834 fi
835 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
903 836
904 ( 837 (
905 # wrap the env here so that the 'insinto' call 838 # wrap the env here so that the 'insinto' call
906 # doesn't corrupt the env of the caller 839 # doesn't corrupt the env of the caller
907 insinto /usr/share/applications 840 insinto /usr/share/applications
908 doins "${desktop}" 841 doins "${desktop}"
909 ) 842 ) || die "installing desktop file failed"
910} 843}
911 844
912# Make a GDM/KDM Session file 845# @FUNCTION: validate_desktop_entries
913# 846# @USAGE: [directories]
914# make_desktop_entry(<title>, <command>) 847# @MAINTAINER:
915# title: File to execute to start the Window Manager 848# Carsten Lohrke <carlo@gentoo.org>
916# command: Name of the Window Manager 849# @DESCRIPTION:
850# Validate desktop entries using desktop-file-utils
851validate_desktop_entries() {
852 if [[ -x /usr/bin/desktop-file-validate ]] ; then
853 einfo "Checking desktop entry validity"
854 local directories=""
855 for d in /usr/share/applications $@ ; do
856 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
857 done
858 if [[ -n ${directories} ]] ; then
859 for FILE in $(find ${directories} -name "*\.desktop" \
860 -not -path '*.hidden*' | sort -u 2>/dev/null)
861 do
862 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
863 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
864 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
865 done
866 fi
867 echo ""
868 else
869 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
870 fi
871}
917 872
873# @FUNCTION: make_session_desktop
874# @USAGE: <title> <command> [command args...]
875# @DESCRIPTION:
876# Make a GDM/KDM Session file. The title is the file to execute to start the
877# Window Manager. The command is the name of the Window Manager.
878#
879# You can set the name of the file via the ${wm} variable.
918make_session_desktop() { 880make_session_desktop() {
919 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 881 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
920 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 882 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
921 883
922 local title=$1 884 local title=$1
923 local command=$2 885 local command=$2
924 local desktop=${T}/${wm}.desktop 886 local desktop=${T}/${wm:-${PN}}.desktop
887 shift 2
925 888
889 cat <<-EOF > "${desktop}"
926echo "[Desktop Entry] 890 [Desktop Entry]
927Encoding=UTF-8
928Name=${title} 891 Name=${title}
929Comment=This session logs you into ${title} 892 Comment=This session logs you into ${title}
930Exec=${command} 893 Exec=${command} $*
931TryExec=${command} 894 TryExec=${command}
932Type=Application" > "${desktop}" 895 Type=XSession
896 EOF
933 897
898 (
899 # wrap the env here so that the 'insinto' call
900 # doesn't corrupt the env of the caller
934 insinto /usr/share/xsessions 901 insinto /usr/share/xsessions
935 doins "${desktop}" 902 doins "${desktop}"
903 )
936} 904}
937 905
906# @FUNCTION: domenu
907# @USAGE: <menus>
908# @DESCRIPTION:
909# Install the list of .desktop menu files into the appropriate directory
910# (/usr/share/applications).
938domenu() { 911domenu() {
912 (
913 # wrap the env here so that the 'insinto' call
914 # doesn't corrupt the env of the caller
939 local i j 915 local i j ret=0
940 insinto /usr/share/applications 916 insinto /usr/share/applications
941 for i in "$@" ; do 917 for i in "$@" ; do
942 if [[ -f ${i} ]] ; then 918 if [[ -f ${i} ]] ; then
943 doins "${i}" 919 doins "${i}"
920 ((ret+=$?))
944 elif [[ -d ${i} ]] ; then 921 elif [[ -d ${i} ]] ; then
945 for j in "${i}"/*.desktop ; do 922 for j in "${i}"/*.desktop ; do
946 doins "${j}" 923 doins "${j}"
924 ((ret+=$?))
947 done 925 done
926 else
927 ((++ret))
948 fi 928 fi
949 done 929 done
930 exit ${ret}
931 )
950} 932}
933
934# @FUNCTION: newmenu
935# @USAGE: <menu> <newname>
936# @DESCRIPTION:
937# Like all other new* functions, install the specified menu as newname.
951newmenu() { 938newmenu() {
939 (
940 # wrap the env here so that the 'insinto' call
941 # doesn't corrupt the env of the caller
952 insinto /usr/share/applications 942 insinto /usr/share/applications
953 newins "$1" "$2" 943 newins "$@"
944 )
954} 945}
955 946
947# @FUNCTION: doicon
948# @USAGE: <list of icons>
949# @DESCRIPTION:
950# Install the list of icons into the icon directory (/usr/share/pixmaps).
951# This is useful in conjunction with creating desktop/menu files.
956doicon() { 952doicon() {
953 (
954 # wrap the env here so that the 'insinto' call
955 # doesn't corrupt the env of the caller
957 local i j 956 local i j ret
958 insinto /usr/share/pixmaps 957 insinto /usr/share/pixmaps
959 for i in "$@" ; do 958 for i in "$@" ; do
960 if [[ -f ${i} ]] ; then 959 if [[ -f ${i} ]] ; then
961 doins "${i}" 960 doins "${i}"
961 ((ret+=$?))
962 elif [[ -d ${i} ]] ; then 962 elif [[ -d ${i} ]] ; then
963 for j in "${i}"/*.png ; do 963 for j in "${i}"/*.png ; do
964 doins "${j}" 964 doins "${j}"
965 ((ret+=$?))
965 done 966 done
967 else
968 ((++ret))
966 fi 969 fi
967 done 970 done
971 exit ${ret}
972 )
968} 973}
974
975# @FUNCTION: newicon
976# @USAGE: <icon> <newname>
977# @DESCRIPTION:
978# Like all other new* functions, install the specified icon as newname.
969newicon() { 979newicon() {
980 (
981 # wrap the env here so that the 'insinto' call
982 # doesn't corrupt the env of the caller
970 insinto /usr/share/pixmaps 983 insinto /usr/share/pixmaps
971 newins "$1" "$2" 984 newins "$@"
985 )
972} 986}
973 987
974############################################################## 988# @FUNCTION: strip-linguas
975# END: Handle .desktop files and menu entries # 989# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
976############################################################## 990# @DESCRIPTION:
977
978
979# for internal use only (unpack_pdv and unpack_makeself)
980find_unpackable_file() {
981 local src=$1
982 if [[ -z ${src} ]] ; then
983 src=${DISTDIR}/${A}
984 else
985 if [[ -e ${DISTDIR}/${src} ]] ; then
986 src=${DISTDIR}/${src}
987 elif [[ -e ${PWD}/${src} ]] ; then
988 src=${PWD}/${src}
989 elif [[ -e ${src} ]] ; then
990 src=${src}
991 fi
992 fi
993 [[ ! -e ${src} ]] && return 1
994 echo "${src}"
995}
996
997# Unpack those pesky pdv generated files ...
998# They're self-unpacking programs with the binary package stuffed in
999# the middle of the archive. Valve seems to use it a lot ... too bad
1000# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1001#
1002# Usage: unpack_pdv [file to unpack] [size of off_t]
1003# - you have to specify the off_t size ... i have no idea how to extract that
1004# information out of the binary executable myself. basically you pass in
1005# the size of the off_t type (in bytes) on the machine that built the pdv
1006# archive. one way to determine this is by running the following commands:
1007# strings <pdv archive> | grep lseek
1008# strace -elseek <pdv archive>
1009# basically look for the first lseek command (we do the strings/grep because
1010# sometimes the function call is _llseek or something) and steal the 2nd
1011# parameter. here is an example:
1012# root@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1013# lseek
1014# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1015# lseek(3, -4, SEEK_END) = 2981250
1016# thus we would pass in the value of '4' as the second parameter.
1017unpack_pdv() {
1018 local src=$(find_unpackable_file $1)
1019 local sizeoff_t=$2
1020
1021 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1022 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1023
1024 local shrtsrc=$(basename "${src}")
1025 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1026 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"`
1027 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"`
1028
1029 # grab metadata for debug reasons
1030 local metafile="$(emktemp)"
1031 tail -c +$((${metaskip}+1)) ${src} > ${metafile}
1032
1033 # rip out the final file name from the metadata
1034 local datafile="`tail -c +$((${metaskip}+1)) ${src} | strings | head -n 1`"
1035 datafile="`basename ${datafile}`"
1036
1037 # now lets uncompress/untar the file if need be
1038 local tmpfile="$(emktemp)"
1039 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1040
1041 local iscompressed="`file -b ${tmpfile}`"
1042 if [ "${iscompressed:0:8}" == "compress" ] ; then
1043 iscompressed=1
1044 mv ${tmpfile}{,.Z}
1045 gunzip ${tmpfile}
1046 else
1047 iscompressed=0
1048 fi
1049 local istar="`file -b ${tmpfile}`"
1050 if [ "${istar:0:9}" == "POSIX tar" ] ; then
1051 istar=1
1052 else
1053 istar=0
1054 fi
1055
1056 #for some reason gzip dies with this ... dd cant provide buffer fast enough ?
1057 #dd if=${src} ibs=${metaskip} count=1 \
1058 # | dd ibs=${tailskip} skip=1 \
1059 # | gzip -dc \
1060 # > ${datafile}
1061 if [ ${iscompressed} -eq 1 ] ; then
1062 if [ ${istar} -eq 1 ] ; then
1063 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1064 | head -c $((${metaskip}-${tailskip})) \
1065 | tar -xzf -
1066 else
1067 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1068 | head -c $((${metaskip}-${tailskip})) \
1069 | gzip -dc \
1070 > ${datafile}
1071 fi
1072 else
1073 if [ ${istar} -eq 1 ] ; then
1074 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1075 | head -c $((${metaskip}-${tailskip})) \
1076 | tar --no-same-owner -xf -
1077 else
1078 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1079 | head -c $((${metaskip}-${tailskip})) \
1080 > ${datafile}
1081 fi
1082 fi
1083 true
1084 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1085 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1086}
1087
1088# Unpack those pesky makeself generated files ...
1089# They're shell scripts with the binary package tagged onto
1090# the end of the archive. Loki utilized the format as does
1091# many other game companies.
1092#
1093# Usage: unpack_makeself [file to unpack] [offset] [tail|dd]
1094# - If the file is not specified then unpack will utilize ${A}.
1095# - If the offset is not specified then we will attempt to extract
1096# the proper offset from the script itself.
1097unpack_makeself() {
1098 local src_input=${1:-${A}}
1099 local src=$(find_unpackable_file "${src_input}")
1100 local skip=$2
1101 local exe=$3
1102
1103 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1104
1105 local shrtsrc=$(basename "${src}")
1106 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1107 if [[ -z ${skip} ]] ; then
1108 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}')
1109 local skip=0
1110 exe=tail
1111 case ${ver} in
1112 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1113 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1114 ;;
1115 2.0|2.0.1)
1116 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1117 ;;
1118 2.1.1)
1119 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1120 let skip="skip + 1"
1121 ;;
1122 2.1.2)
1123 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1124 let skip="skip + 1"
1125 ;;
1126 2.1.3)
1127 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1128 let skip="skip + 1"
1129 ;;
1130 2.1.4|2.1.5)
1131 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1132 skip=$(head -n ${skip} "${src}" | wc -c)
1133 exe="dd"
1134 ;;
1135 *)
1136 eerror "I'm sorry, but I was unable to support the Makeself file."
1137 eerror "The version I detected was '${ver}'."
1138 eerror "Please file a bug about the file ${shrtsrc} at"
1139 eerror "http://bugs.gentoo.org/ so that support can be added."
1140 die "makeself version '${ver}' not supported"
1141 ;;
1142 esac
1143 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1144 fi
1145 case ${exe} in
1146 tail) exe="tail -n +${skip} '${src}'";;
1147 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";;
1148 *) die "makeself cant handle exe '${exe}'"
1149 esac
1150
1151 # lets grab the first few bytes of the file to figure out what kind of archive it is
1152 local tmpfile="$(emktemp)"
1153 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1154 local filetype="$(file -b "${tmpfile}")"
1155 case ${filetype} in
1156 *tar\ archive)
1157 eval ${exe} | tar --no-same-owner -xf -
1158 ;;
1159 bzip2*)
1160 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1161 ;;
1162 gzip*)
1163 eval ${exe} | tar --no-same-owner -xzf -
1164 ;;
1165 compress*)
1166 eval ${exe} | gunzip | tar --no-same-owner -xf -
1167 ;;
1168 *)
1169 eerror "Unknown filetype \"${filetype}\" ?"
1170 false
1171 ;;
1172 esac
1173 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1174}
1175
1176# Display a license for user to accept.
1177#
1178# Usage: check_license [license]
1179# - If the file is not specified then ${LICENSE} is used.
1180check_license() {
1181 local lic=$1
1182 if [ -z "${lic}" ] ; then
1183 lic="${PORTDIR}/licenses/${LICENSE}"
1184 else
1185 if [ -e "${PORTDIR}/licenses/${lic}" ] ; then
1186 lic="${PORTDIR}/licenses/${lic}"
1187 elif [ -e "${PWD}/${lic}" ] ; then
1188 lic="${PWD}/${lic}"
1189 elif [ -e "${lic}" ] ; then
1190 lic="${lic}"
1191 fi
1192 fi
1193 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1194 local l="`basename ${lic}`"
1195
1196 # here is where we check for the licenses the user already
1197 # accepted ... if we don't find a match, we make the user accept
1198 local shopts=$-
1199 local alic
1200 set -o noglob #so that bash doesn't expand "*"
1201 for alic in ${ACCEPT_LICENSE} ; do
1202 if [[ ${alic} == * || ${alic} == ${l} ]]; then
1203 set +o noglob; set -${shopts} #reset old shell opts
1204 return 0
1205 fi
1206 done
1207 set +o noglob; set -$shopts #reset old shell opts
1208
1209 local licmsg="$(emktemp)"
1210 cat << EOF > ${licmsg}
1211**********************************************************
1212The following license outlines the terms of use of this
1213package. You MUST accept this license for installation to
1214continue. When you are done viewing, hit 'q'. If you
1215CTRL+C out of this, the install will not run!
1216**********************************************************
1217
1218EOF
1219 cat ${lic} >> ${licmsg}
1220 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1221 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1222 read alic
1223 case ${alic} in
1224 yes|Yes|y|Y)
1225 return 0
1226 ;;
1227 *)
1228 echo;echo;echo
1229 eerror "You MUST accept the license to continue! Exiting!"
1230 die "Failed to accept license"
1231 ;;
1232 esac
1233}
1234
1235# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1236# the whole 'non-interactive' policy, but damnit I want CD support !
1237#
1238# with these cdrom functions we handle all the user interaction and
1239# standardize everything. all you have to do is call cdrom_get_cds()
1240# and when the function returns, you can assume that the cd has been
1241# found at CDROM_ROOT.
1242#
1243# normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1244# etc... if you want to give the cds better names, then just export
1245# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
1246# - CDROM_NAME="fooie cd" - for when you only want 1 cd
1247# - CDROM_NAME_1="install cd" - for when you want more than 1 cd
1248# CDROM_NAME_2="data cd"
1249# - CDROM_NAME_SET=( "install cd" "data cd" ) - short hand for CDROM_NAME_#
1250#
1251# for those multi cd ebuilds, see the cdrom_load_next_cd() below.
1252#
1253# Usage: cdrom_get_cds <file on cd1> [file on cd2] [file on cd3] [...]
1254# - this will attempt to locate a cd based upon a file that is on
1255# the cd ... the more files you give this function, the more cds
1256# the cdrom functions will handle
1257cdrom_get_cds() {
1258 # first we figure out how many cds we're dealing with by
1259 # the # of files they gave us
1260 local cdcnt=0
1261 local f=
1262 for f in "$@" ; do
1263 ((++cdcnt))
1264 export CDROM_CHECK_${cdcnt}="$f"
1265 done
1266 export CDROM_TOTAL_CDS=${cdcnt}
1267 export CDROM_CURRENT_CD=1
1268
1269 # now we see if the user gave use CD_ROOT ...
1270 # if they did, let's just believe them that it's correct
1271 if [[ -n ${CD_ROOT}${CD_ROOT_1} ]] ; then
1272 local var=
1273 cdcnt=0
1274 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1275 ((++cdcnt))
1276 var="CD_ROOT_${cdcnt}"
1277 [[ -z ${!var} ]] && var="CD_ROOT"
1278 if [[ -z ${!var} ]] ; then
1279 eerror "You must either use just the CD_ROOT"
1280 eerror "or specify ALL the CD_ROOT_X variables."
1281 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables."
1282 die "could not locate CD_ROOT_${cdcnt}"
1283 fi
1284 done
1285 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1286 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1287 export CDROM_SET=-1
1288 for f in ${CDROM_CHECK_1//:/ } ; do
1289 ((++CDROM_SET))
1290 [[ -e ${CD_ROOT}/${f} ]] && break
1291 done
1292 export CDROM_MATCH=${f}
1293 return
1294 fi
1295
1296 # User didn't help us out so lets make sure they know they can
1297 # simplify the whole process ...
1298 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1299 einfo "This ebuild will need the ${CDROM_NAME:-cdrom for ${PN}}"
1300 echo
1301 einfo "If you do not have the CD, but have the data files"
1302 einfo "mounted somewhere on your filesystem, just export"
1303 einfo "the variable CD_ROOT so that it points to the"
1304 einfo "directory containing the files."
1305 echo
1306 einfo "For example:"
1307 einfo "export CD_ROOT=/mnt/cdrom"
1308 echo
1309 else
1310 if [[ -n ${CDROM_NAME_SET} ]] ; then
1311 # Translate the CDROM_NAME_SET array into CDROM_NAME_#
1312 cdcnt=0
1313 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1314 ((++cdcnt))
1315 export CDROM_NAME_${cdcnt}="${CDROM_NAME_SET[$((${cdcnt}-1))]}"
1316 done
1317 fi
1318
1319 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1320 cdcnt=0
1321 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1322 ((++cdcnt))
1323 var="CDROM_NAME_${cdcnt}"
1324 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}"
1325 done
1326 echo
1327 einfo "If you do not have the CDs, but have the data files"
1328 einfo "mounted somewhere on your filesystem, just export"
1329 einfo "the following variables so they point to the right place:"
1330 einfon ""
1331 cdcnt=0
1332 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1333 ((++cdcnt))
1334 echo -n " CD_ROOT_${cdcnt}"
1335 done
1336 echo
1337 einfo "Or, if you have all the files in the same place, or"
1338 einfo "you only have one cdrom, you can export CD_ROOT"
1339 einfo "and that place will be used as the same data source"
1340 einfo "for all the CDs."
1341 echo
1342 einfo "For example:"
1343 einfo "export CD_ROOT_1=/mnt/cdrom"
1344 echo
1345 fi
1346
1347 export CDROM_SET=""
1348 export CDROM_CURRENT_CD=0
1349 cdrom_load_next_cd
1350}
1351
1352# this is only used when you need access to more than one cd.
1353# when you have finished using the first cd, just call this function.
1354# when it returns, CDROM_ROOT will be pointing to the second cd.
1355# remember, you can only go forward in the cd chain, you can't go back.
1356cdrom_load_next_cd() {
1357 local var
1358 ((++CDROM_CURRENT_CD))
1359
1360 unset CDROM_ROOT
1361 var=CD_ROOT_${CDROM_CURRENT_CD}
1362 [[ -z ${!var} ]] && var="CD_ROOT"
1363 if [[ -z ${!var} ]] ; then
1364 var="CDROM_CHECK_${CDROM_CURRENT_CD}"
1365 _cdrom_locate_file_on_cd ${!var}
1366 else
1367 export CDROM_ROOT=${!var}
1368 fi
1369
1370 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1371}
1372
1373# this is used internally by the cdrom_get_cds() and cdrom_load_next_cd()
1374# functions. this should *never* be called from an ebuild.
1375# all it does is try to locate a give file on a cd ... if the cd isn't
1376# found, then a message asking for the user to insert the cdrom will be
1377# displayed and we'll hang out here until:
1378# (1) the file is found on a mounted cdrom
1379# (2) the user hits CTRL+C
1380_cdrom_locate_file_on_cd() {
1381 local mline=""
1382 local showedmsg=0
1383
1384 while [[ -z ${CDROM_ROOT} ]] ; do
1385 local i=0
1386 local -a cdset=(${*//:/ })
1387 if [[ -n ${CDROM_SET} ]] ; then
1388 cdset=(${cdset[${CDROM_SET}]})
1389 fi
1390
1391 while [[ -n ${cdset[${i}]} ]] ; do
1392 local dir=$(dirname ${cdset[${i}]})
1393 local file=$(basename ${cdset[${i}]})
1394
1395 for mline in $(mount | gawk '/(iso|cdrom|fs=cdfss)/ {print $3}') ; do
1396 [[ -d ${mline}/${dir} ]] || continue
1397 if [[ -n $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] ; then
1398 export CDROM_ROOT=${mline}
1399 export CDROM_SET=${i}
1400 export CDROM_MATCH=${cdset[${i}]}
1401 return
1402 fi
1403 done
1404
1405 ((++i))
1406 done
1407
1408 echo
1409 if [[ ${showedmsg} -eq 0 ]] ; then
1410 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1411 if [[ -z ${CDROM_NAME} ]] ; then
1412 einfo "Please insert+mount the cdrom for ${PN} now !"
1413 else
1414 einfo "Please insert+mount the ${CDROM_NAME} cdrom now !"
1415 fi
1416 else
1417 if [[ -z ${CDROM_NAME_1} ]] ; then
1418 einfo "Please insert+mount cd #${CDROM_CURRENT_CD} for ${PN} now !"
1419 else
1420 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1421 einfo "Please insert+mount the ${!var} cdrom now !"
1422 fi
1423 fi
1424 showedmsg=1
1425 fi
1426 einfo "Press return to scan for the cd again"
1427 einfo "or hit CTRL+C to abort the emerge."
1428 echo
1429 einfo "If you are having trouble with the detection"
1430 einfo "of your CD, it is possible that you do not have"
1431 einfo "Joliet support enabled in your kernel. Please"
1432 einfo "check that CONFIG_JOLIET is enabled in your kernel."
1433 read || die "something is screwed with your system"
1434 done
1435}
1436
1437# Make sure that LINGUAS only contains languages that 991# Make sure that LINGUAS only contains languages that
1438# a package can support 992# a package can support. The first form allows you to
1439# 993# specify a list of LINGUAS. The -i builds a list of po
1440# usage: strip-linguas <allow LINGUAS> 994# files found in all the directories and uses the
1441# strip-linguas -i <directories of .po files> 995# intersection of the lists. The -u builds a list of po
1442# strip-linguas -u <directories of .po files> 996# files found in all the directories and uses the union
1443# 997# of the lists.
1444# The first form allows you to specify a list of LINGUAS.
1445# The -i builds a list of po files found in all the
1446# directories and uses the intersection of the lists.
1447# The -u builds a list of po files found in all the
1448# directories and uses the union of the lists.
1449strip-linguas() { 998strip-linguas() {
1450 local ls newls nols 999 local ls newls nols
1451 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1000 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1452 local op=$1; shift 1001 local op=$1; shift
1453 ls=$(find "$1" -name '*.po' -exec basename {} .po \;); shift 1002 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1454 local d f 1003 local d f
1455 for d in "$@" ; do 1004 for d in "$@" ; do
1456 if [[ ${op} == "-u" ]] ; then 1005 if [[ ${op} == "-u" ]] ; then
1457 newls=${ls} 1006 newls=${ls}
1458 else 1007 else
1459 newls="" 1008 newls=""
1460 fi 1009 fi
1461 for f in $(find "$d" -name '*.po' -exec basename {} .po \;) ; do 1010 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1462 if [[ ${op} == "-i" ]] ; then 1011 if [[ ${op} == "-i" ]] ; then
1463 hasq ${f} ${ls} && newls="${newls} ${f}" 1012 has ${f} ${ls} && newls="${newls} ${f}"
1464 else 1013 else
1465 hasq ${f} ${ls} || newls="${newls} ${f}" 1014 has ${f} ${ls} || newls="${newls} ${f}"
1466 fi 1015 fi
1467 done 1016 done
1468 ls=${newls} 1017 ls=${newls}
1469 done 1018 done
1470 else 1019 else
1472 fi 1021 fi
1473 1022
1474 nols="" 1023 nols=""
1475 newls="" 1024 newls=""
1476 for f in ${LINGUAS} ; do 1025 for f in ${LINGUAS} ; do
1477 if hasq ${f} ${ls} ; then 1026 if has ${f} ${ls} ; then
1478 newls="${newls} ${f}" 1027 newls="${newls} ${f}"
1479 else 1028 else
1480 nols="${nols} ${f}" 1029 nols="${nols} ${f}"
1481 fi 1030 fi
1482 done 1031 done
1483 [[ -n ${nols} ]] \ 1032 [[ -n ${nols} ]] \
1484 && ewarn "Sorry, but ${PN} does not support the LINGUAs:" ${nols} 1033 && einfo "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1485 export LINGUAS=${newls:1} 1034 export LINGUAS=${newls:1}
1486} 1035}
1487 1036
1488# moved from kernel.eclass since they are generally useful outside of 1037# @FUNCTION: preserve_old_lib
1489# kernel.eclass -iggy (20041002) 1038# @USAGE: <libs to preserve> [more libs]
1490 1039# @DESCRIPTION:
1491# the following functions are useful in kernel module ebuilds, etc.
1492# for an example see ivtv or drbd ebuilds
1493
1494# set's ARCH to match what the kernel expects
1495set_arch_to_kernel() {
1496 i=10
1497 while ((i--)) ; do
1498 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1499 done
1500 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}"
1501 case ${ARCH} in
1502 x86) export ARCH="i386";;
1503 amd64) export ARCH="x86_64";;
1504 hppa) export ARCH="parisc";;
1505 mips) export ARCH="mips";;
1506 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one!
1507 *) export ARCH="${ARCH}";;
1508 esac
1509}
1510
1511# set's ARCH back to what portage expects
1512set_arch_to_portage() {
1513 i=10
1514 while ((i--)) ; do
1515 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1516 done
1517 export ARCH="${EUTILS_ECLASS_PORTAGE_ARCH}"
1518}
1519
1520# Jeremy Huddleston <eradicator@gentoo.org>:
1521# preserve_old_lib /path/to/libblah.so.0
1522# preserve_old_lib_notify /path/to/libblah.so.0
1523#
1524# These functions are useful when a lib in your package changes --library. Such 1040# These functions are useful when a lib in your package changes ABI SONAME.
1525# an example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0 1041# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1526# would break packages that link against it. Most people get around this 1042# would break packages that link against it. Most people get around this
1527# by using the portage SLOT mechanism, but that is not always a relevant 1043# by using the portage SLOT mechanism, but that is not always a relevant
1528# solution, so instead you can add the following to your ebuilds: 1044# solution, so instead you can call this from pkg_preinst. See also the
1529# 1045# preserve_old_lib_notify function.
1530# src_install() {
1531# ...
1532# preserve_old_lib /usr/$(get_libdir)/libogg.so.0
1533# ...
1534# }
1535#
1536# pkg_postinst() {
1537# ...
1538# preserve_old_lib_notify /usr/$(get_libdir)/libogg.so.0
1539# ...
1540# }
1541
1542preserve_old_lib() { 1046preserve_old_lib() {
1543 LIB=$1 1047 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1048 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1049 die "Invalid preserve_old_lib() usage"
1050 fi
1051 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1544 1052
1545 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1053 # let portage worry about it
1546 SONAME=`basename ${LIB}` 1054 has preserve-libs ${FEATURES} && return 0
1547 DIRNAME=`dirname ${LIB}`
1548 1055
1549 dodir ${DIRNAME} 1056 local lib dir
1550 cp ${ROOT}${LIB} ${D}${DIRNAME} 1057 for lib in "$@" ; do
1058 [[ -e ${ROOT}/${lib} ]] || continue
1059 dir=${lib%/*}
1060 dodir ${dir} || die "dodir ${dir} failed"
1061 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1551 touch ${D}${LIB} 1062 touch "${D}"/${lib}
1552 fi 1063 done
1553} 1064}
1554 1065
1066# @FUNCTION: preserve_old_lib_notify
1067# @USAGE: <libs to notify> [more libs]
1068# @DESCRIPTION:
1069# Spit helpful messages about the libraries preserved by preserve_old_lib.
1555preserve_old_lib_notify() { 1070preserve_old_lib_notify() {
1556 LIB=$1 1071 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1072 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1073 die "Invalid preserve_old_lib_notify() usage"
1074 fi
1557 1075
1558 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1076 # let portage worry about it
1559 SONAME=`basename ${LIB}` 1077 has preserve-libs ${FEATURES} && return 0
1560 1078
1079 local lib notice=0
1080 for lib in "$@" ; do
1081 [[ -e ${ROOT}/${lib} ]] || continue
1082 if [[ ${notice} -eq 0 ]] ; then
1083 notice=1
1561 ewarn "An old version of an installed library was detected on your system." 1084 ewarn "Old versions of installed libraries were detected on your system."
1562 ewarn "In order to avoid breaking packages that link against it, this older version" 1085 ewarn "In order to avoid breaking packages that depend on these old libs,"
1563 ewarn "is not being removed. In order to make full use of this newer version," 1086 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1564 ewarn "you will need to execute the following command:" 1087 ewarn "in order to remove these old dependencies. If you do not have this"
1088 ewarn "helper program, simply emerge the 'gentoolkit' package."
1089 ewarn
1090 fi
1091 # temp hack for #348634 #357225
1092 [[ ${PN} == "mpfr" ]] && lib=${lib##*/}
1565 ewarn " revdep-rebuild --library ${SONAME}" 1093 ewarn " # revdep-rebuild --library '${lib}'"
1094 done
1095 if [[ ${notice} -eq 1 ]] ; then
1566 ewarn 1096 ewarn
1567 ewarn "After doing that, you can safely remove ${LIB}" 1097 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1568 ewarn "Note: 'emerge gentoolkit' to get revdep-rebuild" 1098 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1099 for lib in "$@" ; do
1100 ewarn " # rm '${lib}'"
1101 done
1569 fi 1102 fi
1570} 1103}
1571 1104
1572# Hack for people to figure out if a package was built with 1105# @FUNCTION: built_with_use
1573# certain USE flags 1106# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1107# @DESCRIPTION:
1574# 1108#
1575# Usage: built_with_use [-a|-o] <DEPEND ATOM> <List of USE flags> 1109# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1576# ex: built_with_use xchat gtk2
1577# 1110#
1578# Flags: -a all USE flags should be utilized 1111# A temporary hack until portage properly supports DEPENDing on USE
1579# -o at least one USE flag should be utilized 1112# flags being enabled in packages. This will check to see if the specified
1580# Note: the default flag is '-a' 1113# DEPEND atom was built with the specified list of USE flags. The
1114# --missing option controls the behavior if called on a package that does
1115# not actually support the defined USE flags (aka listed in IUSE).
1116# The default is to abort (call die). The -a and -o flags control
1117# the requirements of the USE flags. They correspond to "and" and "or"
1118# logic. So the -a flag means all listed USE flags must be enabled
1119# while the -o flag means at least one of the listed IUSE flags must be
1120# enabled. The --hidden option is really for internal use only as it
1121# means the USE flag we're checking is hidden expanded, so it won't be found
1122# in IUSE like normal USE flags.
1123#
1124# Remember that this function isn't terribly intelligent so order of optional
1125# flags matter.
1581built_with_use() { 1126built_with_use() {
1127 local hidden="no"
1128 if [[ $1 == "--hidden" ]] ; then
1129 hidden="yes"
1130 shift
1131 fi
1132
1133 local missing_action="die"
1134 if [[ $1 == "--missing" ]] ; then
1135 missing_action=$2
1136 shift ; shift
1137 case ${missing_action} in
1138 true|false|die) ;;
1139 *) die "unknown action '${missing_action}'";;
1140 esac
1141 fi
1142
1582 local opt=$1 1143 local opt=$1
1583 [[ ${opt:0:1} = "-" ]] && shift || opt="-a" 1144 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1584 1145
1585 local PKG=$(best_version $1) 1146 local PKG=$(best_version $1)
1586 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package" 1147 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1587 shift 1148 shift
1588 1149
1589 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE 1150 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1151 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1590 1152
1591 # if the USE file doesnt exist, assume the $PKG is either 1153 # if the IUSE file doesn't exist, the read will error out, we need to handle
1592 # injected or package.provided 1154 # this gracefully
1155 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1156 case ${missing_action} in
1157 true) return 0;;
1158 false) return 1;;
1593 [[ ! -e ${USEFILE} ]] && die "Unable to determine what USE flags $PKG was built with" 1159 die) die "Unable to determine what USE flags $PKG was built with";;
1160 esac
1161 fi
1162
1163 if [[ ${hidden} == "no" ]] ; then
1164 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1165 # Don't check USE_EXPAND #147237
1166 local expand
1167 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1168 if [[ $1 == ${expand}_* ]] ; then
1169 expand=""
1170 break
1171 fi
1172 done
1173 if [[ -n ${expand} ]] ; then
1174 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1175 case ${missing_action} in
1176 true) return 0;;
1177 false) return 1;;
1178 die) die "$PKG does not actually support the $1 USE flag!";;
1179 esac
1180 fi
1181 fi
1182 fi
1594 1183
1595 local USE_BUILT=$(<${USEFILE}) 1184 local USE_BUILT=$(<${USEFILE})
1596 while [[ $# -gt 0 ]] ; do 1185 while [[ $# -gt 0 ]] ; do
1597 if [[ ${opt} = "-o" ]] ; then 1186 if [[ ${opt} = "-o" ]] ; then
1598 has $1 ${USE_BUILT} && return 0 1187 has $1 ${USE_BUILT} && return 0
1602 shift 1191 shift
1603 done 1192 done
1604 [[ ${opt} = "-a" ]] 1193 [[ ${opt} = "-a" ]]
1605} 1194}
1606 1195
1196# @FUNCTION: epunt_cxx
1197# @USAGE: [dir to scan]
1198# @DESCRIPTION:
1607# Many configure scripts wrongly bail when a C++ compiler 1199# Many configure scripts wrongly bail when a C++ compiler could not be
1608# could not be detected. #73450 1200# detected. If dir is not specified, then it defaults to ${S}.
1201#
1202# http://bugs.gentoo.org/73450
1609epunt_cxx() { 1203epunt_cxx() {
1610 local dir=$1 1204 local dir=$1
1611 [[ -z ${dir} ]] && dir=${S} 1205 [[ -z ${dir} ]] && dir=${S}
1612 ebegin "Removing useless C++ checks" 1206 ebegin "Removing useless C++ checks"
1613 local f 1207 local f
1614 for f in $(find ${dir} -name configure) ; do 1208 find "${dir}" -name configure | while read f ; do
1615 patch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null 1209 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1616 done 1210 done
1617 eend 0 1211 eend 0
1618} 1212}
1619 1213
1620# dopamd <file> [more files] 1214# @FUNCTION: make_wrapper
1621# 1215# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1622# Install pam auth config file in /etc/pam.d 1216# @DESCRIPTION:
1623dopamd() { 1217# Create a shell wrapper script named wrapper in installpath
1624 [[ -z $1 ]] && die "dopamd requires at least one argument" 1218# (defaults to the bindir) to execute target (default of wrapper) by
1625 1219# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1626 use pam || return 0 1220# libpaths followed by optionally changing directory to chdir.
1627
1628 INSDESTTREE=/etc/pam.d \
1629 doins "$@" || die "failed to install $@"
1630}
1631# newpamd <old name> <new name>
1632#
1633# Install pam file <old name> as <new name> in /etc/pam.d
1634newpamd() {
1635 [[ $# -ne 2 ]] && die "newpamd requires two arguements"
1636
1637 use pam || return 0
1638
1639 INSDESTTREE=/etc/pam.d \
1640 newins "$1" "$2" || die "failed to install $1 as $2"
1641}
1642
1643# make a wrapper script ...
1644# NOTE: this was originally games_make_wrapper, but I noticed other places where
1645# this could be used, so I have moved it here and made it not games-specific
1646# -- wolf31o2
1647# $1 == wrapper name
1648# $2 == binary to run
1649# $3 == directory to chdir before running binary
1650# $4 == extra LD_LIBRARY_PATH's (make it : delimited)
1651# $5 == path for wrapper
1652make_wrapper() { 1221make_wrapper() {
1653 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5 1222 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1654 local tmpwrapper=$(emktemp) 1223 local tmpwrapper=$(emktemp)
1655 # We don't want to quote ${bin} so that people can pass complex 1224 # We don't want to quote ${bin} so that people can pass complex
1656 # things as $bin ... "./someprog --args" 1225 # things as $bin ... "./someprog --args"
1666fi 1235fi
1667exec ${bin} "\$@" 1236exec ${bin} "\$@"
1668EOF 1237EOF
1669 chmod go+rx "${tmpwrapper}" 1238 chmod go+rx "${tmpwrapper}"
1670 if [[ -n ${path} ]] ; then 1239 if [[ -n ${path} ]] ; then
1240 (
1671 exeinto "${path}" 1241 exeinto "${path}"
1672 newexe "${tmpwrapper}" "${wrapper}" 1242 newexe "${tmpwrapper}" "${wrapper}"
1243 ) || die
1673 else 1244 else
1674 newbin "${tmpwrapper}" "${wrapper}" 1245 newbin "${tmpwrapper}" "${wrapper}" || die
1246 fi
1247}
1248
1249# @FUNCTION: path_exists
1250# @USAGE: [-a|-o] <paths>
1251# @DESCRIPTION:
1252# Check if the specified paths exist. Works for all types of paths
1253# (files/dirs/etc...). The -a and -o flags control the requirements
1254# of the paths. They correspond to "and" and "or" logic. So the -a
1255# flag means all the paths must exist while the -o flag means at least
1256# one of the paths must exist. The default behavior is "and". If no
1257# paths are specified, then the return value is "false".
1258path_exists() {
1259 local opt=$1
1260 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1261
1262 # no paths -> return false
1263 # same behavior as: [[ -e "" ]]
1264 [[ $# -eq 0 ]] && return 1
1265
1266 local p r=0
1267 for p in "$@" ; do
1268 [[ -e ${p} ]]
1269 : $(( r += $? ))
1270 done
1271
1272 case ${opt} in
1273 -a) return $(( r != 0 )) ;;
1274 -o) return $(( r == $# )) ;;
1275 esac
1276}
1277
1278# @FUNCTION: in_iuse
1279# @USAGE: <flag>
1280# @DESCRIPTION:
1281# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1282# as necessary.
1283#
1284# Note that this function should not be used in the global scope.
1285in_iuse() {
1286 debug-print-function ${FUNCNAME} "${@}"
1287 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1288
1289 local flag=${1}
1290 local liuse=( ${IUSE} )
1291
1292 has "${flag}" "${liuse[@]#[+-]}"
1293}
1294
1295# @FUNCTION: use_if_iuse
1296# @USAGE: <flag>
1297# @DESCRIPTION:
1298# Return true if the given flag is in USE and IUSE.
1299#
1300# Note that this function should not be used in the global scope.
1301use_if_iuse() {
1302 in_iuse $1 || return 1
1303 use $1
1304}
1305
1306# @FUNCTION: usex
1307# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1308# @DESCRIPTION:
1309# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1310# otherwise echo [false output][false suffix] (defaults to "no").
1311usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1312
1313# @FUNCTION: makeopts_jobs
1314# @USAGE: [${MAKEOPTS}]
1315# @DESCRIPTION:
1316# Searches the arguments (defaults to ${MAKEOPTS}) and extracts the jobs number
1317# specified therein. i.e. if the user has MAKEOPTS=-j9, this will show "9".
1318# We can't return the number as bash normalizes it to [0, 255]. If the flags
1319# haven't specified a -j flag, then "1" is shown as that is the default `make`
1320# uses. Useful for running non-make tools in parallel too.
1321makeopts_jobs() {
1322 [[ $# -eq 0 ]] && set -- ${MAKEOPTS}
1323 local x jobs
1324 for x ; do [[ ${x} == -j* ]] && jobs=${x#-j} ; done
1325 echo ${jobs:-1}
1326}
1327
1328check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1329
1675 fi 1330fi
1676}

Legend:
Removed from v.1.247  
changed lines
  Added in v.1.391

  ViewVC Help
Powered by ViewVC 1.1.20